window.Rusnometr = class Rusnometr
    stiffness: 0.07
    handDelay: 10_frames
    scale: 135_degrees
    wiggleIntensity: 1/50
    wiggleBaseRange: 0.05
    maxDifference: 9
    (@$container) ->
        @$handDel         = @$container.find \.rucicka
        @$inFavor         = @$container.find '.pro .value'
        @$against         = @$container.find '.proti .value'
        @$inBuilding      = @$container.find '.celkem .value'
        @$remaining       = @$container.find '.zbyva .value'
        @$percentage      = @$container.find '.procenta .value'
        @$voteAccumulator = @$container.find '.hlasAccumulator'

        @targetValue       = 0
        @currentValue      = 0
        @forceQueue        = new Array @handDelay
        @increment         = 0
        @wiggle            = 0
        @resultUncertainty = 1

    setValues: (votesInFavor, votesAgainst, votesAbstained, inBuilding, lastVoteName, lastVodeType) ->
        lastVoteTypeString = switch lastVodeType
            | 1 => "pro"
            | -1 => "proti návrhu"
            | 0 => "zdržel(a) se"
            | _ => null
        percentage = votesInFavor / (votesInFavor + votesAgainst)
        remaining = inBuilding - votesInFavor - votesAgainst - votesAbstained
        @resultUncertainty = remaining / inBuilding
        difference = votesInFavor - votesAgainst
        if difference > @maxDifference
            difference = @maxDifference
        else if difference < @maxDifference * -1
            difference = @maxDifference * -1
        @targetValue = difference / @maxDifference
        @$percentage.html Math.round percentage*100
        @$inFavor.html votesInFavor
        @$against.html votesAgainst
        @$inBuilding.html inBuilding
        @$remaining.html remaining
        return if not lastVoteTypeString
        $ "<div class='hlas'>
                Poslední hlas: <span class='name'>#lastVoteName</span> &ndash; <span class='dir'>#{lastVoteTypeString}</span>
            </div>" .prependTo @$voteAccumulator

    redraw: (time) ->
        if !@lastAnimationFrameTime
            @lastAnimationFrameTime = time
        timeDifference = time - @lastAnimationFrameTime
        @lastAnimationFrameTime = time

        steps = Math.min do
            Math.round timeDifference / 15
            @handDelay
        for [0 to steps]
            index = @increment % @handDelay
            @recomputeWiggle!
            difference = @targetValue - @currentValue
            if @resultUncertainty > 0
                difference += @wiggle
            force = difference * @stiffness
            @forceQueue[index] = force
            ++@increment
        currentChange = @forceQueue[index] || 0
        @currentValue += currentChange
        if currentChange
            degrees  = @toDegrees @currentValue
            @$handDel.css do
                transform       : "rotate(#{degrees}deg)"
                WebkitTransform : "rotate(#{degrees}deg)"
                MsTransform     : "rotate(#{degrees}deg)"
                MozTransform    : "rotate(#{degrees}deg)"
                OTransform      : "rotate(#{degrees}deg)"

        requestAnimationFrame rusnometr~redraw

    toDegrees: (value) ->
        (@scale / 2 * value) * -1

    recomputeWiggle: ->
        wiggleRange = @wiggleBaseRange * @resultUncertainty
        wiggleOffset = switch
            | @wiggle > wiggleRange *  2 => 0.65
            | @wiggle > wiggleRange *  1 => 0.8
            | @wiggle < wiggleRange * -2 => 0.35
            | @wiggle < wiggleRange * -1 => 0.2
            | otherwise       => 0.5
        @wiggle += (Math.random! - wiggleOffset) * @wiggleIntensity

window.rusnometr = new Rusnometr $ ".ampermetr"
# rusnometr.redraw!
servers =
    'http://80.79.23.187'
    'http://195.140.252.93'
allServers = servers.slice 0
requestAnimationFrame rusnometr~redraw
processMessage = ({status}:data) ->
    rusnometr~setValues ...status


attemptConnection = ->
    if not servers.length
        servers := allServers.slice 0
    index = Math.min do
        Math.round Math.random! * (servers.length) - 0.5
        servers.length - 1
    address = servers[index]
    socket = io.connect address
        ..on \news processMessage
        ..on \connect_failed ->
            servers.splice index, 1
            attemptConnection!
        ..on \disconnect ->
            servers.splice index, 1
            attemptConnection!
        ..on \error ->
            servers.splice index, 1
            attemptConnection!

attemptConnection!
